######PROGRAMA EM R PARA AJUSTE DE MODELOS DE TRANSIO, INCLUINDO EFEITOS ALEATRIOS######
                ######Idemauro Antonio Rodrigues de Lara#######
                    ###UNIVERSIDADE FEDERAL DO PARAN###


##Rotina de preparao do conjunto de dados
dados=read.table('c:\\ohio.txt',header=T)


#Arquvivo dropout conjunto para ajuste de modelos de transio estacionrios

# n  o nmero de novos vetores a criar e t o nmero de momentos em que
# a varivel foi observada.

desloca=function(dados,resp,n,t){
varind=matrix(0,nrow(dados),n)
for(j in 1:n){
varind[,j]=c(rep(0,j),resp[1:(nrow(dados)-j)])
varind[seq(j,nrow(dados),t),j]=NA
if(j>1)
varind[which(is.na(varind[,(j-1)])),j]=NA}
list('novodata'=data.frame(dados,varind))}



drop=desloca(dados,dados[,"resp"],1,4)
drop=data.frame(drop)
drop=na.omit(drop)
names(drop)=c("suj","tempo","fuma","resp","prev1")



#### Ajuste de modelos exploratrios e seleo de modelos####

attach(drop)
mod1a<-glm(resp~fuma+prev1, family=binomial)
summary(mod1a)
mod2a<-glm(resp~fuma+prev1+fuma*prev1, family=binomial)
summary(mod2a)



#Ajustando modelos com interceptos aleatrios

library(glmmML)
mod4a<-glmmML(resp~fuma+prev1, cluster=suj, family=binomial)#via Laplace
mod5a<-glmmML(resp~fuma+prev1, cluster=suj, family=binomial,method="ghq",n.points=12) #via quadratura gaussiana

